#include "heap.hpp"

namespace AG{

  template <typename T>
  void heap<T>::insert(T t, unsigned int k, unsigned int maxheap)
  {
    unsigned int j = 2*k;  // right children, rememeber pos 0 is empty
    
    while (j<=maxheap){

      if (j < maxheap && item_[j] < item_[j+1]) // righ < left children ?
	j++;                                     //   compare with left
      if (t >= item_[j])                         // t >= both children
	break;                                   // stop heap cond ok
      else
	{
	  item_[k] = item_[j];                   // take largest children
	  k = j;                                 // this can potentially
	  j = 2 * k;                             // violate heap cond
	}                                        // so verify it
    }
    item_[k] = t;                                // got the right position
  };

  template <typename T>
  void heap<T>::make_heap()
  {
    // > N/2 are already preserving heap
    for (unsigned int i = size_/2; i >=1 ; i--)
      insert(item_[i], i, size_);      
  };

  template <typename T>
  void heap<T>::sort()
  {
    T t;
    unsigned int maxheap = size_;

    while (maxheap > 0){
      
      t = item_[maxheap];           // take the min
      item_[maxheap] = item_[1];    // the max goes to its place
      insert(t, 1, --maxheap);      // one position is ok
                                    // verify if the other violate heap
    }
  };

};
