#ifndef HEAP_HEADER_
#define HEAP_HEADER_
#include <iostream>

namespace AG{

  template <typename T>
  class heap{

  protected:

    unsigned int size_;  // the size of the array    
    T * item_;           // pointer to an array of items

    void insert(T t, unsigned int start, unsigned int maxheap);

  public:
    
    heap(unsigned int heapsize = 100) : 
      size_(heapsize), item_(new T[heapsize+1]) {}; // leave pos 0 empty
    ~heap()
    { delete [] item_ ; }

    void make_heap();
    void sort();
    
    // this is quite interesting it works with both side, being a reference
    // h[i] = j and h[j]
    //
    // rememeber that position 0 is empty

    T& operator[](const unsigned int i) { return item_[i+1];}

    friend std::ostream& operator<< (std::ostream& os, heap<T>& heap){
      
      for (unsigned int i = 1 ; i <= heap.size_; i++)
	os << "heap[" << i << "]=" << heap.item_[i] << std::endl;
      
      return os;
    };
  };

};

#include "heap.cpp"
#endif
